pen.define(["viz-CrossFilter/Identity","common-ui/vizapi/VizController", "viz-CrossFilter/CrossFilter"], function(identity){

  analyzerPlugins = typeof analyzerPlugins == "undefined" ? [] : analyzerPlugins;

  analyzerPlugins.push(
      {
        pluginId: identity.pluginId,
        vizId: identity.vizId,
        
        init:function () {
          dojo.require("pentaho.common.Messages");
          pentaho.common.Messages.addUrlBundle(this.pluginId,CONTEXT_PATH+'i18n?plugin='+this.pluginId+'&name=resources/messages/messages');

            if( pentaho.palettes && pentaho.palettes[0].name == 'palette 1' ) {
                pentaho.palettes.splice( 0, 0, {
                    name: 'default',
                    colors: [
                    "#0d8ecf",
                    "#b0de09",
                    "#fcd202",
                    "#ff6600",
                    "#cd0d74",
                    "#cc0000",
                    "#00cc00",
                    "#650cd0",
                    "#3a3a3a",
                    "#7272e3",
                    "#79c1e4",
                    "#d3ed77",
                    "#fde673",
                    "#ffaa72",
                    "#e379b2",
                    "#e37272",
                    "#72e372",
                    "#aa79e5",
                    "#929292",
                    "#00007a",
                    "#07547b",
                    "#698405",
                    "#967c01",
                    "#983b00",
                    "#7a0745",
                    "#7a0000",
                    "#007a00",
                    "#3c077b",
                    "#000000"]
                } );
            }

          // Register types to display in Analyzer
          if(!cv.pentahoVisualizations){
            cv.pentahoVisualizations = [];
          }
          var vis = pentaho.visualizations.getById(this.vizId);
          if( vis ) {
            cv.pentahoVisualizations.push(vis);
          } else {
            console.log('ERROR: could not find visualization - '+this.vizId );
            return;
          }
          vis.name = pentaho.common.Messages.getString(this.vizId);
          cv.pentahoVisualizationHelpers[this.vizId] = {
            vizId: this.vizId,
            previousAction: null,
            canRefreshReport:function(report) {

              var vis = pentaho.visualizations.getById(this.vizId);
              if(vis.helper && vis.helper.canRefreshReport) {
                return vis.helper.canRefreshReport(report);
              }
            },
            generateOptionsFromAnalyzerState:function (report) {
              var userDefinedOpts = {};

              // set the last action taken
              if(report.visualization.args.configAction !== 'undefined' && report.visualization.args.configAction != null) {
                report.visualization.args.configAction = null;
              } else if(report.history.current() != null) {
                var action = report.history.current().action;
                this.previousAction = action;
              }
              return userDefinedOpts;
            }

          };

          dojo.declare("analyzer."+this.vizId+"Config", [analyzer.ColorConfiguration], {
            onModelEvent:function (config, item, eventName, args) {
              if (eventName == "value") {
                // works by convention where the ids of the data req items match the property names
                this.report.visualization.args[item.id] = args.newVal;
                if(typeof(args.prevVal) != "undefined" && args.prevVal != args.newVal){
                  this.report.visualization.args.configAction = item.id + "Changed";
                }
              }
              this.inherited(arguments); // Let super class handle the insertAt and removedGem events
            },
            _setScalingType:function (scalingType) {
              this.report.visualization.args.scalingType = scalingType;
            },
            _setColorRange:function (range) {
              this.report.visualization.args.colorRange = range;
            },
            getConfiguration:function () {
              var config = this.inherited(arguments);
              return config;
            },
            updateConfiguration: function(config){
            }

          });
          analyzer.LayoutPanel.configurationManagers["JSON_"+this.vizId] = analyzer[this.vizId+'Config'];

        }
      }
  );

});

